Subject: [Teas] IETF TE Topology YANG Model Design Meeting Notes - 2017-05-17

From: Xufeng Liu <[email-masked]>
Date: Tue, 23 May 2017 14:18:44 +0000

Attendees: Igor, Xufeng, Carlo, Dieter, Sergio, Rakesh, Young, Tarek

- NMDA discussion (https://tools.ietf.org/html/draft-dsdt-nmda-guidelines-01) for three options:
1) Compromised position: Publish with the current model, and start an NMDA compliant revision in TEAS WG.
   > Proposed by Kent:
     "Perhaps, in the spirit of doing the right thing, the TEAS WG can commit to adopting a draft to publish the NMDA-compatible model ASAP?"

2) NMDA module in main body, and current module in a non-normative appendix.
   > Comment from Lou:
     "Keep in mind that the non-nmda modules will still be in a Standards Track RFC,  just in an appendix.  I suspect those that would be discouraged by a non-PS document will miss the subtly of the implications of being in an appendix..."

3) NMDA module in main body, a new state model in appendix, and current model in another appendix with a new name space.
   > Proposed by Rob Wilton:
     https://github.com/rgwilton/ietf-models-to-combined
   "I've just generated the necessary "-state" modules as well, and committed them to the same github repository above.

    I've also checked that that the modules compile cleanly by confdc (to check the xpaths) as well as pyang.

    It is worth noting the the changeset to convert the "ietf-te-topology" from the current draft to NMDA style is only about 175 lines.  I had another 24 line diff to the te-types.yang as well.  I.e. we are really not talking about a big change here (diffs attached, and combined generated trees attached).

    Given that the modules haven't even been through YANG doctor review yet (which could easily change the structure of the modules), and given that removing the "config/state" containers is a formulaic change (which I believe I've already done) then I guess that I don't really see why they don't now follow the agreed guidance that they were previously waiting for.

    I.e.
    - Publish the NMDA style modules in the body of the draft.
    - Publish the extra -state modules in the appendix.
    - Publish the current draft modules in another appendix (in a separate namespace).

    It feels that adding in the NMDA shouldn't really significantly slow the document progress down, and choosing to publish the current model as the main standard seems like a strange choice for IETF to take when we know that the module has the wrong structure to the future direction in IETF, and that fixing the draft now to comply seems to be of relatively cheap cost (compared to the overhead of the YANG doctor review, WG last call, and IESG publication process).

    Perhaps this draft would be a good test to ensure that the datastore guidelines process works well."

-----
Attendees discussed the three options above, and agreed that:
Option 1) is preferred.
  > The solution fits our situation best.
  > Publish the current version with the current structure ASAP.
  > The current on-going implementations can continue without restructuring.
  > The NMDA compatible model will be the next version, with a new document, incorcorporating furthur experiences from implementations.
  > NMDA compatible implementation can start in a year or so with planned structure upgrades, when updated protocol specifications and implementations are available.

- Discussed some type sharing with TE tunnel model
  > disjointness
   o Xufeng will move this type to te-types.

  typedef te-path-disjointness {
    type bits {
      bit node {
        position 0;
        description "Node disjoint.";
      }
      bit link {
        position 1;
        description "Link disjoint.";
      }
      bit srlg {
        position 2;
        description "SRLG (Shared Risk Link Group) disjoint.";
      }
    }
    description
      "Type of the resource disjointness for a TE tunnel path.";
    reference
      "RFC4872: RSVP-TE Extensions in Support of End-to-End
       Generalized Multi-Protocol Label Switching (GMPLS)
       Recovery";
  } // te-path-disjointness

  > path-properties
   o Tarek will move the grouping to te-types

Thanks,

- Xufeng

Note: Please drop me an email if you need an invite for joining the weekly call.